FusionHUD = LibStub("AceAddon-3.0"):NewAddon("FusionHUD", "AceConsole-3.0");

local options = {
    name = "Fusion HUD",
    handler = FusionHUD,
    type = 'group',
    args = {
    },
}

LibStub("AceConfig-3.0"):RegisterOptionsTable("FusionHUD", options, {"fusionhud", "fh"});

local FusionHUDMasterFrame = CreateFrame("Frame", nil, UIParent);
local FusionHUDPlayerHealthFrame = CreateFrame("Frame", nil, FusionHUDMasterFrame);
local FusionHUDPlayerPowerFrame = CreateFrame("Frame", nil, FusionHUDMasterFrame);
local FusionHUDPlayerHealthText = FusionHUDPlayerHealthFrame:CreateFontString(nil, "LOW");
local FusionHUDPlayerPowerText = FusionHUDPlayerPowerFrame:CreateFontString(nil, "LOW");

function FusionHUD:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("FusionHUD", options, {"fusion", "fh"})
	
	FusionHUDMasterFrame:SetClampedToScreen(true);
	FusionHUDMasterFrame:SetPoint("CENTER",UIParent,"CENTER");
	FusionHUDMasterFrame:SetFrameStrata("LOW");
	FusionHUDMasterFrame:SetHeight(400);
	FusionHUDMasterFrame:SetWidth(400);
	FusionHUDMasterFrame:Show();
	FusionHUDMasterFrame:SetAlpha(1);
	
	FusionHUDPlayerHealthFrame:ClearAllPoints();
	FusionHUDPlayerHealthFrame:SetPoint("BOTTOMRIGHT", FusionHUDMasterFrame, "BOTTOMLEFT");
	FusionHUDPlayerHealthFrame:SetHeight(400);
	FusionHUDPlayerHealthFrame:SetWidth(15);
	
	FusionHUDPlayerHealthFrame.playerHealthBar = FusionHUDPlayerHealthFrame:CreateTexture(nil, "BACKGROUND");
	FusionHUDPlayerHealthFrame.playerHealthBar:SetTexture("Interface\\AddOns\\FusionHUD\\Graphics\\White Straight Bar Base", false);
	FusionHUDPlayerHealthFrame.playerHealthBar:ClearAllPoints();
	FusionHUDPlayerHealthFrame.playerHealthBar:SetPoint("BOTTOM", FusionHUDPlayerHealthFrame, "BOTTOM");
	FusionHUDPlayerHealthFrame.playerHealthBar:SetVertexColor(0,1,0,1);
	FusionHUDPlayerHealthFrame.playerHealthBar:SetHeight(400);
	FusionHUDPlayerHealthFrame.playerHealthBar:SetWidth(15);
	FusionHUDPlayerHealthFrame.playerHealthBar:SetTexCoord(0,1,1,0);
	
	FusionHUDPlayerHealthFrame.playerHealthContainer = FusionHUDPlayerHealthFrame:CreateTexture(nil, "OVERLAY");
	FusionHUDPlayerHealthFrame.playerHealthContainer:SetTexture("Interface\\AddOns\\FusionHUD\\Graphics\\Straight Bar Glass Container", false);
	FusionHUDPlayerHealthFrame.playerHealthContainer:ClearAllPoints();
	FusionHUDPlayerHealthFrame.playerHealthContainer:SetPoint("BOTTOM", FusionHUDPlayerHealthFrame, "BOTTOM");
	FusionHUDPlayerHealthFrame.playerHealthContainer:SetHeight(400);
	FusionHUDPlayerHealthFrame.playerHealthContainer:SetWidth(15);
	FusionHUDPlayerHealthFrame.playerHealthContainer:SetTexCoord(0,1,1,0);
	FusionHUDPlayerHealthFrame.playerHealthContainer:SetBlendMode("BLEND");  
	
	FusionHUDPlayerHealthText:ClearAllPoints();
	FusionHUDPlayerHealthText:SetPoint("TOP", FusionHUDPlayerHealthFrame, "BOTTOM");
	FusionHUDPlayerHealthText:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE, MONOCHROME");
	FusionHUDPlayerHealthText:SetJustifyH("CENTER");
	FusionHUDPlayerHealthText:SetJustifyV("TOP");
	FusionHUDPlayerHealthText:SetVertexColor(0,1,0,1);
	FusionHUDPlayerHealthText:SetHeight(25);
	FusionHUDPlayerHealthText:SetWidth(120);
	
	FusionHUDPlayerPowerFrame:ClearAllPoints();
	FusionHUDPlayerPowerFrame:SetPoint("BOTTOMLEFT", FusionHUDMasterFrame, "BOTTOMRIGHT");
	FusionHUDPlayerPowerFrame:SetHeight(400);
	FusionHUDPlayerPowerFrame:SetWidth(15);

	FusionHUDPlayerPowerFrame.playerPowerBar = FusionHUDPlayerPowerFrame:CreateTexture(nil, "BACKGROUND");
	FusionHUDPlayerPowerFrame.playerPowerBar:SetTexture("Interface\\AddOns\\FusionHUD\\Graphics\\White Straight Bar Base", false);
	FusionHUDPlayerPowerFrame.playerPowerBar:ClearAllPoints();
	FusionHUDPlayerPowerFrame.playerPowerBar:SetPoint("BOTTOM", FusionHUDPlayerPowerFrame, "BOTTOM");
	FusionHUDPlayerPowerFrame.playerPowerBar:SetVertexColor(1,1,0,1);
	FusionHUDPlayerPowerFrame.playerPowerBar:SetHeight(400);
	FusionHUDPlayerPowerFrame.playerPowerBar:SetWidth(15);
	FusionHUDPlayerPowerFrame.playerPowerBar:SetTexCoord(0,1,1,0);
	
	FusionHUDPlayerPowerFrame.playerPowerContainer = FusionHUDPlayerPowerFrame:CreateTexture(nil, "OVERLAY");
	FusionHUDPlayerPowerFrame.playerPowerContainer:SetTexture("Interface\\AddOns\\FusionHUD\\Graphics\\Straight Bar Glass Container", false);
	FusionHUDPlayerPowerFrame.playerPowerContainer:ClearAllPoints();
	FusionHUDPlayerPowerFrame.playerPowerContainer:SetPoint("BOTTOM", FusionHUDPlayerPowerFrame, "BOTTOM");
	FusionHUDPlayerPowerFrame.playerPowerContainer:SetHeight(400);
	FusionHUDPlayerPowerFrame.playerPowerContainer:SetWidth(15);
	FusionHUDPlayerPowerFrame.playerPowerContainer:SetTexCoord(0,1,1,0);
	FusionHUDPlayerPowerFrame.playerPowerContainer:SetBlendMode("BLEND"); 
	
	FusionHUDPlayerPowerText:ClearAllPoints();
	FusionHUDPlayerPowerText:SetPoint("TOP", FusionHUDPlayerPowerFrame, "BOTTOM");
	FusionHUDPlayerPowerText:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE, MONOCHROME");
	FusionHUDPlayerPowerText:SetJustifyH("CENTER");
	FusionHUDPlayerPowerText:SetJustifyV("TOP");
	FusionHUDPlayerPowerText:SetVertexColor(1,1,0,1);
	FusionHUDPlayerPowerText:SetHeight(25);
	FusionHUDPlayerPowerText:SetWidth(120);
	
	
	
	FusionHUDMasterFrame:SetScript("OnUpdate", 	function() 
													FusionHUD:UpdatePower();
													FusionHUD:UpdateHealth();
												end); 

	
	FusionHUD:RegisterChatCommand("fusion", "DebugFunction");
	
end

function FusionHUD:UpdateHealth()
	FusionHUDPlayerHealthFrame.playerHealthBar:SetHeight(400*UnitHealth("player")/UnitHealthMax("player"));
	FusionHUDPlayerHealthFrame.playerHealthBar:SetTexCoord(0,1,UnitHealth("player")/UnitHealthMax("player"),0);
	FusionHUDPlayerHealthText:SetText(UnitHealth("player") .. "/" .. UnitHealthMax("player"));
end

function FusionHUD:UpdatePower()
	local powerBarHeight = 400*UnitMana("player")/UnitManaMax("player");
	local powerType, powerTypeString = UnitPowerType("player");
	if powerTypeString == "RAGE" then
		FusionHUDPlayerPowerFrame.playerPowerBar:SetVertexColor(0.8,0,0,1);
		FusionHUDPlayerPowerText:SetVertexColor(0.8,0,0,1);
	elseif powerTypeString == "RUNIC_POWER" then
		FusionHUDPlayerPowerFrame.playerPowerBar:SetVertexColor(0.6,0,0,1);
		FusionHUDPlayerPowerText:SetVertexColor(0.6,0,0,1);
	elseif powerTypeString == "MANA" then
		FusionHUDPlayerPowerFrame.playerPowerBar:SetVertexColor(0,0,0.8,1);
		FusionHUDPlayerPowerText:SetVertexColor(0,0,0.8,1);
	elseif powerTypeString == "FOCUS" then
		FusionHUDPlayerPowerFrame.playerPowerBar:SetVertexColor(0.8,0.3,0,1);
		FusionHUDPlayerPowerText:SetVertexColor(0.8,0.3,0,1);
	else
		FusionHUDPlayerPowerFrame.playerPowerBar:SetVertexColor(1,1,0,1);
		FusionHUDPlayerPowerText:SetVertexColor(1,1,0,1);
	end
	if powerBarHeight == 0 then
		FusionHUDPlayerPowerFrame.playerPowerBar:SetHeight(1);
	else
		FusionHUDPlayerPowerFrame.playerPowerBar:SetHeight(powerBarHeight);
	end
	FusionHUDPlayerPowerFrame.playerPowerBar:SetTexCoord(0,1,UnitMana("player")/UnitManaMax("player"),0);
	FusionHUDPlayerPowerText:SetText(UnitMana("player") .. "/" .. UnitManaMax("player"));
end

function FusionHUD:DebugFunction(input)
	FusionHUD:Print("I'm here!");
end



